package com.itko.tph;

import com.itko.lisa.gui.WizardStep;
import com.itko.lisa.test.TestCase;
import com.itko.lisa.test.TestExec;
import com.itko.lisa.test.TestNode;
import com.itko.lisa.vse.stateful.ConversationalStep;
import com.itko.lisa.vse.stateful.model.Request;
import com.itko.lisa.vse.stateful.model.Response;
import com.itko.lisa.vse.stateful.model.Transaction;
import com.itko.lisa.vse.stateful.protocol.TransportProtocol;
import com.itko.lisa.vse.stateful.recorder.RecordingSession;
import com.itko.lisa.vse.stateful.recorder.RecordingWizard;
import com.itko.lisa.vse.stateful.recorder.WizardPhase;

public class TestTPH extends TransportProtocol {

	@Override
	protected void beginRecordProcess(TestExec testExec) throws Exception {
		System.out.println("**********Begin recording");
		
		Transaction t = new Transaction();
		Request req = t.getRequest();
		Response rsp = new Response();
		
		req.setBody("This is a request");
		req.setOperation("Operation 1");
		req.getMetaData().put( ConversationalStep.SESSION_KEY, "token" );
		
		rsp.setBody("This is a response");
		t.addResponse(rsp);
		
		addTransaction(t);
	}

	@Override
	public TestNode createListenStep(TestCase testCase) {
		System.out.println("**********Create listen step");
		TestNode listenStep = RecordingSession.createStep( testCase, "FTP Listen", FTPListenStep.class );
        return listenStep;
	}

	@Override
	public TestNode createRespondStep(TestCase testCase) {
		System.out.println("**********Create respond step");
		TestNode responseStep = RecordingSession.createStep( testCase, "FTP Responder", FTPResponseStep.class );
		return responseStep;
	}

	@Override
	protected void endRecordProcess() {
		System.out.println("**********End recording");
	}

	@Override
	public WizardStep[] getWizardSteps(RecordingWizard arg0, WizardPhase arg1) {
		
		return null;
	}
	
	
}
